/*==========================================================================*/
/*                                                                          */
/* Function : ComboDemo()                                                   */
/*                                                                          */
/* Purpose  : Shows all three styles of combo boxes                         */
/*                                                                          */
/* Returns  :                                                               */
/*                                                                          */
/*==========================================================================*/
#include "wmewldem.h"

#define ID_DROPDOWN                       1002
#define ID_DROPDOWNLIST                   1003
#define ID_SIMPLE                         1004


VOID FAR PASCAL ComboDemo(void)
{
  FARPROC lpfn;

#if 0
  MessageBox(hMain,
            "To pulldown the hidden listbox portion of a combobox,\
click on the combobox arrow icon or press F4 or ALT-GREY-DOWN.",
                     "Combo box demo", MB_OK);
#endif

  lpfn = MakeProcInstance((FARPROC) ComboDialogProc, hAppInstance);
  DialogBox(hAppInstance, "ComboDemoDlg", hMain, lpfn);
  FreeProcInstance(lpfn);
}


int FAR PASCAL ComboDialogProc(HWND hDlg, WORD msg, WORD wParam, DWORD lParam)
{
  int i, id;

  static char *szColors[] =
  {
    "Black", "Blue",    "Green",  "Cyan", 
    "Red",   "Magenta", "Yellow", "White",
    NULL
  };


  (void) lParam;

  switch (msg)
  {
    case WM_INITDIALOG :
      for (id = ID_DROPDOWN;  id <= ID_SIMPLE;  id++)
      {
        SendDlgItemMessage(hDlg, id, WM_SETREDRAW, FALSE, 0L);
        for (i = 0;  szColors[i];  i++)
          SendDlgItemMessage(hDlg,id,CB_ADDSTRING,0, (DWORD)(LPSTR)szColors[i]);
        SendDlgItemMessage(hDlg, id, CB_SETCURSEL, 2, 0L);
        i = (int) SendDlgItemMessage(hDlg, id, CB_GETCURSEL, 0, 0L);
        SendDlgItemMessage(hDlg, id, WM_SETREDRAW, TRUE, 0L);
      }
      return TRUE;

    case WM_COMMAND :
      switch (wParam)
      {
        case IDOK     :
        case IDCANCEL :
          EndDialog(hDlg, TRUE);
          break;
      }
      return TRUE;
  }
  return FALSE;
}

