############################################################################
#                                                                          #
#  MAKEFILE for WMEWLDEM for MetaWare's HighC and GFX                      #
#                                                                          #
############################################################################

# Compiler is 'M' for Microsoft, 'T' for Borland Turbo C
COMPILER = H
# Model is 
#   1) Microsoft C - 'M' for Medium, 'L' for Large
#   2) Turbo C - 'm' for medium, 'l' for large
MODEL = f

MEWELPATH=\mewel
# Change this path to the path where your BC++ is installed
ROOT=f:\highc

CC = hc386
#CFLAGS = -DMEWEL_GUI -g -Hpragma=on(CodeView) @highc.opt
CFLAGS = -DMEWEL_GUI @highc.opt
LIB = tlib
LINK = tlink
LFLAGS = /L$(MEWELPATH);$(ROOT)\lib $(DEBUG) /s /o 

# Inference rules for C and ASM files

.c.obj :
	$(CC) $(CFLAGS) $*.c

.asm.obj :
	$(ASM) $(ASMFLAGS) $*;

.rc.res :
	$(MEWELPATH)\rc32 $*


DEMO = wmewldem
OBJS = $(DEMO).obj button.obj clock.obj combo.obj hexcalc.obj listbox.obj \
       mouse.obj notepad.obj scrolbar.obj static.obj
OBJ  = $(DEMO) button clock combo hexcalc listbox mouse notepad scrolbar \
       static

all         :   $(DEMO).exp


$(DEMO).obj :   $(DEMO).c
	$(CC) $(CFLAGS) -DMEWELMAIN -DNOMDI $*.c

button.obj  :   button.c
	$(CC) $(CFLAGS) $*.c

clock.obj  :   clock.c
	$(CC) $(CFLAGS) $*.c

combo.obj  :   combo.c
	$(CC) $(CFLAGS) $*.c

hexcalc.obj  :   hexcalc.c
	$(CC) $(CFLAGS) $*.c

listbox.obj  :   listbox.c
	$(CC) $(CFLAGS) $*.c

mouse.obj  :   mouse.c
	$(CC) $(CFLAGS) $*.c

notepad.obj  :   notepad.c
	$(CC) $(CFLAGS) $*.c

scrollbar.obj  :   scrollbar.c
	$(CC) $(CFLAGS) $*.c

static.obj  :   static.c
	$(CC) $(CFLAGS) $*.c


$(DEMO).res :   $(DEMO).rc static.dlg button.dlg clockdat.bin

clockdat.bin: clockdat.asm
    masm clockdat;
    tlink clockdat;
    exe2bin clockdat
    del clockdat.exe

$(DEMO).exp :   $(OBJS) \mewel\winlibhg.lib
	386link @highc.lnk
#386link @highcdbg.lnk

