/*===========================================================================*/
/*                                                                           */
/* File    : MOUSE.C                                                         */
/*                                                                           */
/* Purpose : Demonstrates mouse tracking                                     */
/*                                                                           */
/* History :                                                                 */
/*                                                                           */
/* (C) Copyright 1989-1992 Marc Adler/Magma Systems     All Rights Reserved  */
/*===========================================================================*/
#include "wmewldem.h"

extern HWND hMouseWnd;


VOID FAR PASCAL MouseDemo(void)
{
  TEXTMETRIC tm;
  HDC   hDC;
  DWORD dwExtent;


  /*
    Don't create 2 mouse windows
  */
  if (hMouseWnd)
    return;

  /*
    See if the system has a mouse installed
  */
  if (!GetSystemMetrics(SM_MOUSEPRESENT))
  {
    MessageBox(hMain, "You must have a mouse to run this demo.",
                      "Error", MB_OK | MB_ICONEXCLAMATION);
    return;
  }

  /*
    Figure out the proper width and height of the mouse-tracking window
  */
  hDC = GetDC(hMain);
  GetTextMetrics(hDC, (LPTEXTMETRIC) &tm);
  dwExtent = GetTextExtent(hDC, "x=555, y=555", 12);
  ReleaseDC(hMain, hDC);

  /*
    Create the mouse-tracking window.
  */
  hMouseWnd = CreateWindow("MsgWnd",       /* class */
                           "Mouse",        /* title */
                           WS_BORDER | WS_CHILD,
                           MAKE_X(30),
                           MAKE_Y(10),
                           LOWORD(dwExtent) + 2*GetSystemMetrics(SM_CXBORDER),
                           HIWORD(dwExtent) + 2*GetSystemMetrics(SM_CYBORDER),
                           hMain,          /* hParent */
                           0,              /* id */
                           hAppInstance,   /* hInst */
                           0L);            /* lpParam */


  /*
    Show the mouse tracking window
  */
  ShowWindow(hMouseWnd, SW_SHOW);
  UpdateWindow(hMouseWnd);
}

