/*===========================================================================*/
/*                                                                           */
/* File    : MEWLDEMO.C                                                      */
/*                                                                           */
/* Purpose : General purpose demo of the MEWEL Window Library                */
/*                                                                           */
/* History :                                                                 */
/*                                                                           */
/* (C) Copyright 1992 Marc Adler/Magma Systems     All Rights Reserved       */
/*===========================================================================*/
#include "wmewldem.h"

#if defined(MEWEL)
//extern DWORD fProgramState = STATE_NO_XMS;
#endif

/*
  Global Window Handles
*/
HWND hMain;
HWND hMsgWnd;
HWND hTimeWnd;
HWND hMouseWnd = NULL;
HWND hWndCalc = NULL;

#ifdef MODELESSTEST
HWND hWndListbox1 = NULL;
HWND hWndListbox2 = NULL;
HWND hWndString;
#endif

int cxMsgWnd, cyMsgWnd;
int cxTimeWnd;

HANDLE hAppInstance = 0;

#define MM_SHOWTIME    (WM_USER + 243)

#if defined(MEWEL) && defined(__TURBOC__)
extern unsigned _stklen = 8192;
#endif



int PASCAL WinMain(hInstance, hPrevInstance, lpszCmdLine, nCmdShow)
  HANDLE hInstance, hPrevInstance;
  LPSTR  lpszCmdLine;
  int    nCmdShow;
{
  MSG    msg;
  char   szBuf[64];
  HANDLE hAccel;
  RECT   r;
  HDC    hDC;
  TEXTMETRIC tm;
  static DWORD dwLastTick = 0L;

extern VOID PASCAL MEWELWriteDebugString(PSTR);
extern long memavail(void);
extern BOOL MemDebug;

  (void) lpszCmdLine;

#if defined(MEWEL_GUI)
  if (lpszCmdLine[0])
  {
    switch (lpszCmdLine[0])
    {
      case 'c' :
        SET_PROGRAM_STATE(STATE_USE_CLIPREGIONS);
        break;
      case 'C' :
        SET_PROGRAM_STATE(STATE_USE_CLIPREGIONS | STATE_META_CLIP);
        break;
      case 'm' :
        MemDebug = TRUE;
        break;
    }
  }

#if defined(WC386) || defined(__HIGHC__) || defined(DOS286X)
  hInstance = OpenResourceFile("wmewldem");
#endif

#endif


#ifdef MEWEL_TEXT
//VidInitVGAFonts();
#endif

  /*
    Register the main window class.
  */
  if (!hPrevInstance)
    if (!InitApp(hInstance))
      exit(1);

  /*
    Create the main window and set the main window procedure
  */
  LoadString(hInstance, IDS_MAINTITLE, (LPSTR) szBuf, sizeof(szBuf));
  hMain = CreateWindow("Mewldemo",            /* class */
                       szBuf,                 /* title */
                       WS_OVERLAPPEDWINDOW |  /* dwStyle */ 
                       WS_VSCROLL | WS_HSCROLL | WS_THICKFRAME,
                       CW_USEDEFAULT,0,       /* x,y,width,height */
                       CW_USEDEFAULT,0,       /* x,y,width,height */
                       NULL,                  /* hParent */
                       NULL,                  /* hMenu */
                       hInstance,             /* hInst */
                       0L);                   /* lpParam */

  /*
    Load in the accelerator table
  */
  hAccel = LoadAccelerators(hInstance, (LPSTR) "Mewldemo");


  /*
    Get coordinate info to help us set up the message and time windows
  */
  hDC = GetDC(hMain);
  GetTextMetrics(hDC, (LPTEXTMETRIC) &tm);
  GetClientRect(hMain, (LPRECT) &r);

  cyMsgWnd = (tm.tmHeight+tm.tmExternalLeading) +
                       (2*GetSystemMetrics(SM_CYBORDER));
  cxMsgWnd  = 42 * tm.tmAveCharWidth + (2*GetSystemMetrics(SM_CXBORDER));
  cxTimeWnd = LOWORD(GetTextExtent(hDC,"55:55:55",8)) +
                  (2*GetSystemMetrics(SM_CXBORDER));
  ReleaseDC(hMain, hDC);

  /*
    Create a child window to display the output messages.
  */
  hMsgWnd =  CreateWindow("MsgWnd",        /* class */
			   NULL,           /* title */
			   WS_CHILD | WS_BORDER | WS_VISIBLE,       /* dwStyle */
			   0,
			   r.bottom - cyMsgWnd + 1,
                           42 * tm.tmAveCharWidth + (2*GetSystemMetrics(SM_CXBORDER)),
			   cyMsgWnd,
			   hMain,          /* hParent */
			   NULL,           /* hMenu */
			   hInstance,      /* hInst */
			   0L);            /* lpParam */

  /*
    Create a window for the clock
  */
#if 0
  hTimeWnd = CreateWindow("MsgWnd",
			  NULL,
			  WS_CHILD | WS_BORDER | WS_VISIBLE,
			  r.right,
			  r.bottom - cyMsgWnd + 1,
			  8 * tm.tmAveCharWidth + (2*GetSystemMetrics(SM_CXBORDER)),
			  cyMsgWnd,
			  hMain,          /* hParent */
			  NULL,           /* hMenu */
			  hInstance,      /* hInst */
			  0L);            /* lpParam */
#endif


  /*
    Show the window
  */
  ShowWindow(hMain, nCmdShow);
  UpdateWindow(hMain);


  /*
    Main message loop
  */
  for (;;)
  {
    /*
      This is how you can do background processing
    */
    while (!PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {
      DWORD dwTick;

      dwTick = GetTickCount();

#ifdef MEMDEBUG
      if (dwTick >= dwLastTick + 1000)
      {
        unsigned long ul = memavail();
        wsprintf(szBuf, "%lu bytes", ul);
        MEWELWriteDebugString(szBuf);
      }
#endif

      if (hTimeWnd && dwTick >= dwLastTick + 1000)
        SendMessage(hTimeWnd, MM_SHOWTIME, 0, dwTick);

      dwLastTick = dwTick;
    }

    if (msg.message == WM_QUIT)
      break;

    if (msg.message == WM_MOUSEMOVE && hMouseWnd)
    {
      POINT pt;

      pt = MAKEPOINT(msg.lParam);
      wsprintf(szBuf, "x=%3d, y=%3d", pt.y, pt.x);

      hDC = GetDC(hMouseWnd);

      GetClientRect(hMouseWnd, (LPRECT) &r);
      FillRect(hDC, (LPRECT) &r, GetStockObject(LTGRAY_BRUSH));
      TextOut(hDC, 0, 0, (LPSTR) szBuf, lstrlen(szBuf));

      ReleaseDC(hMouseWnd, hDC);
    }

    if (hWndCalc && IsDialogMessage(hWndCalc, &msg))
      continue;

#ifdef MODELESSTEST
    if (hWndListbox1 && IsDialogMessage(hWndListbox1, &msg))
      continue;
    if (hWndListbox2 && IsDialogMessage(hWndListbox2, &msg))
      continue;
#endif

    if (!TranslateAccelerator(hMain, hAccel, &msg))
    {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }

  return 0;
}


/****************************************************************************/
/*                                                                          */
/* Function : InitApp                                                       */
/*                                                                          */
/* Purpose  : Registers the window class                                    */
/*                                                                          */
/* Returns  :                                                               */
/*                                                                          */
/****************************************************************************/
BOOL InitApp(hInstance)
  HANDLE hInstance;
{
  HANDLE    hClass;
  PWNDCLASS pClass;

  hClass = LocalAlloc(LPTR | LMEM_ZEROINIT, sizeof(WNDCLASS));
  pClass = (PWNDCLASS) LocalLock(hClass);

  pClass->hCursor       = LoadCursor(NULL, IDC_ARROW);
//pClass->hIcon         = LoadIcon(NULL, IDI_APPLICATION);
  pClass->hIcon         = LoadIcon(hInstance, "Clock");
  pClass->lpszMenuName  = "MainMenu";
  pClass->lpszClassName = "Mewldemo";
#ifdef MEWEL_TEXT
  pClass->hbrBackground = (HBRUSH) CreateSolidBrush(RGB(0xFF, 0xFF, 0xFF));
#else
  pClass->hbrBackground = (HBRUSH) CreateSolidBrush(RGB(0x00, 0x80, 0x80));
#endif
  pClass->hInstance     = hInstance;
  pClass->style         = CS_HREDRAW | CS_VREDRAW;
  pClass->lpfnWndProc   = MainWndProc;
  if (!RegisterClass((LPWNDCLASS) pClass))
    return FALSE;

  pClass->lpszMenuName  = (LPSTR) NULL;
  pClass->lpszClassName = "MsgWnd";
  pClass->hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
  pClass->lpfnWndProc   = MsgWndProc;
  if (!RegisterClass((LPWNDCLASS) pClass))
    return FALSE;

  /*
    Register the notepad class
  */
  pClass->lpszMenuName  = (LPSTR) "NotePad";
  pClass->lpszClassName = "NotePad";
  pClass->lpfnWndProc   = NotepadWndProc;
  if (!RegisterClass((LPWNDCLASS) pClass))
    return FALSE;

  /*
    Register the timer window
  */
  pClass->lpszMenuName  = (LPSTR) NULL;
  pClass->lpszClassName = "Timer";
  pClass->lpfnWndProc   = TimerWndProc;
  pClass->hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);
  if (!RegisterClass((LPWNDCLASS) pClass))
    return FALSE;

  /*
    Register the calculator window
  */
  pClass->lpszClassName = "HexCalc";
  pClass->lpfnWndProc   = CalcDlgProc;
#ifdef MEWEL_TEXT
  /*
     Calc looks better with a white background in text mode
  */
  pClass->hbrBackground = (HBRUSH) CreateSolidBrush(RGB(0xFF, 0xFF, 0xFF));
#else
  pClass->hbrBackground = (HBRUSH) CreateSolidBrush(RGB(0xFF, 0x00, 0xFF));
#endif
  pClass->cbWndExtra    = DLGWINDOWEXTRA;
  if (!RegisterClass((LPWNDCLASS) pClass))
    return FALSE;


  LocalUnlock(hClass);
  LocalFree(hClass);
  hAppInstance = hInstance;
  return TRUE;			/* Initialization succeeded */
}


/****************************************************************************/
/*                                                                          */
/* Function : MainWndProc                                                   */
/*                                                                          */
/* Purpose  : Window procedure for the main window.                         */
/*                                                                          */
/* Returns  :                                                               */
/*                                                                          */
/****************************************************************************/
LONG FAR PASCAL MainWndProc(HWND hWnd, WORD message, WORD wParam, LONG lParam)
{
  char buf[80];

#define IMS_TEST
#ifdef IMS_TEST
  static BOOL bFillTest = FALSE;
#endif

  switch (message)
  {
    case WM_COMMAND      :
      switch (wParam)
      {
        case ID_LISTDEMO :
          ListboxDemo();
          break;

        case ID_CHILDDEMO:
          ChildDemo();
          break;

        case ID_CALCDEMO :
          Calculator();
          break;

        case ID_TIMEDEMO :
          TimerDemo();
          break;

        case ID_MOUSEDEMO:
          if (hMouseWnd)
          {
            DestroyWindow(hMouseWnd);
            hMouseWnd = NULL;
          }
          else
          {
            MouseDemo();
          }
          CheckMenuItem(GetMenu(hMain), ID_MOUSEDEMO,
                        hMouseWnd ? MF_CHECKED : MF_UNCHECKED);
          break;

        case ID_MENUDEMO:
          DoFloatingPopup();
          break;

        case ID_EDITDEMO :
          NotePad();
          break;

        case ID_COMBODEMO:
          ComboDemo();
          break;

        case ID_STATICDEMO :
          StaticDemo();
          break;

        case ID_BUTTONDEMO :
          ButtonDemo();
          break;

        case ID_CLOCK      :
          ClockDemo();
          break;

       case ID_BITMAPDEMO  :
         BitmapDemo();
         break;


        case ID_WORD50 :
        case ID_WRITE  :
        case ID_EXCEL  :
        case ID_124    :
        case ID_C52    :
        case ID_QUICKC :
        case ID_QUICKBASIC :
        case ID_PASCAL :
          LoadString(hAppInstance, wParam+1000, (LPSTR) buf, sizeof(buf));
          MessageBox(hMain, buf, "WM_COMMAND", MB_OK);
          break;

        case ID_ABOUT   :
          MessageBox(hMain,
                     "MEWEL Window System\nMagma Systems\n(201) 912-0192",
                     "About MEWEL",
                     MB_YESNOCANCEL | MB_ICONASTERISK);
          break;

        case ID_EXIT :
          PostQuitMessage(0);
          break;

        case ID_HELP :
dohelp:
      MessageBox(hWnd,
"MEWEL Demonstration Program\nMagma Systems\n15 Bodwell Terrace\nMillburn, NJ 07041\n\
(201) 912-0192 (voice)\n(201) 912-0668 (BBS)\n(201) 912-0103 (FAX)",
                 "MEWLDEMO", MB_OK | MB_ICONASTERISK);
         break;
      }
      break;


    case WM_VSCROLL :
    case WM_HSCROLL :
      PrintScrollbarValues(hWnd, message, wParam, lParam);
      break;


    case WM_SIZE :
      if (!IsIconic(hWnd))
      {
        RECT r;
        GetClientRect(hWnd, (LPRECT) &r);
        MoveWindow(hMsgWnd, 0, r.bottom - cyMsgWnd+1, cxMsgWnd, cyMsgWnd, TRUE);
        if (hTimeWnd)
          MoveWindow(hTimeWnd, cxMsgWnd, r.bottom - cyMsgWnd+1, cxTimeWnd, cyMsgWnd, TRUE);
      }
      break;

    case WM_MENUSELECT  :
    {
      int  iLen;
      RECT r;
      HDC  hDC;

      /*
        We trigger off of the WM_MENUSELECT message so that we
        can print informative messages about each menu option.
      */

      GetClientRect(hMsgWnd, (LPRECT) &r);
      hDC = GetDC(hMsgWnd);
      FillRect(hDC, (LPRECT) &r, GetStockObject(WHITE_BRUSH));

      /*
        If lParam was <-1,0>, then the user dismissed the menu, so
        we just want to erase the previous help text from the
        status window. If not, then idMenu contains a valid menu or
        submenu identifier. Load the corresponding string from
        the string table, and print it.
      */
      if (LOWORD(lParam) != 0xFFFF || HIWORD(lParam) != 0)
      {
        if ((iLen = LoadString(hAppInstance, wParam, (LPSTR) buf, sizeof(buf))) > 0)
        {
          TextOut(hDC, 0, 0, buf, iLen);
        }
      }

      ReleaseDC(hMsgWnd, hDC);
      break;
    }

    /*
      WM_HELP is a MEWEL-specific message which is sent when a
      menu item withthe HELP attribute is clicked on. 
    */
    case WM_HELP :
      goto dohelp;

#ifdef IMS_TEST
    case WM_CHAR :
      if (wParam == VK_SPACE)
      {
        RECT r;
        bFillTest++;
        SetRect(&r, 200, 100, 300, 150);
        InvalidateRect(hWnd, &r, FALSE);
      }
      break;

   case WM_PAINT :
     if (!bFillTest)
       goto call_dwp;
     else
     {
       HDC hDC;
       PAINTSTRUCT ps;
       RECT r;

       bFillTest = FALSE;
       hDC = BeginPaint(hWnd, &ps);
       GetClientRect(hWnd, &r);
       FillRect(hDC, &r, GetStockObject(WHITE_BRUSH));
       EndPaint(hWnd, &ps);
     }
     break;
#endif


    default :
      /* Call the default window procedure for the main window */
call_dwp:
      return DefWindowProc(hWnd, message, wParam, lParam);
  }
  return TRUE;
}


LONG FAR PASCAL MsgWndProc(HWND hWnd, WORD message, WORD wParam, LONG lParam)
{
  switch (message)
  {
    case MM_SHOWTIME :
    {
      char szBuf[32];
      HDC  hDC;

      lParam /= 1000L;  /* convert millisecs to seconds */
      wsprintf(szBuf, "%02d:%02d:%02d", 
                 (int) (lParam / 3600L),
                 (int) (lParam % 3600L) / 60,
                 (int) (lParam % 3600L) % 60);
      hDC = GetDC(hWnd);
      TextOut(hDC, 0, 0, (LPSTR) szBuf, lstrlen(szBuf));
      ReleaseDC(hWnd, hDC);
      return TRUE;
    }

    default :
      return DefWindowProc(hWnd, message, wParam, lParam);
  }
}



/*===========================================================================*/
/*                                                                           */
/* File    :  MOVETEST.C                                                     */
/*                                                                           */
/* Purpose :  Demo of child windows. Included moving, resizing, and clipping */
/*                                                                           */
/* History :                                                                 */
/*                                                                           */
/* (C) Copyright 1989 Marc Adler/Magma Systems     All Rights Reserved       */
/*===========================================================================*/
extern LONG FAR PASCAL PanelWndProc(HWND, WORD, WORD, LONG);
static VOID PASCAL CreateChildren(HWND);

HWND hPanel1, hPanel2, hPanel3;

static PSTR pszChildMsg = (PSTR) 
"You can move (drag the caption) or resize (drag lower-right corner) \
any of the 3 child windows.\n You can press the arrow keys to scroll \
the panels. This also demonstrates MEWEL clipping sibling windows.";


VOID ChildDemo(VOID)
{
  HANDLE hMemory;
  PWNDCLASS pWndClass;

  TerminateChildDemo();
  MessageBox(hMain, pszChildMsg, "Child Demo", MB_OK);

  hMemory = LocalAlloc(LPTR | LMEM_ZEROINIT, sizeof(WNDCLASS));
  pWndClass = (PWNDCLASS) LocalLock(hMemory);
  pWndClass->hCursor       = LoadCursor(NULL, IDC_ARROW);
  pWndClass->hIcon         = LoadIcon(NULL, IDI_APPLICATION);
  pWndClass->lpszMenuName  = NULL;
  pWndClass->lpszClassName = "Panel";
  pWndClass->lpfnWndProc   = PanelWndProc;
  pWndClass->cbWndExtra    = sizeof(HBRUSH);

  RegisterClass(pWndClass);

  LocalUnlock(hMemory);
  LocalFree(hMemory);


  hPanel1=CreateWindow("Panel",        /* class */
                       "Panel1",       /* title */
                       WS_BORDER  | WS_CHILD |
                       WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX | WS_MAXIMIZEBOX |
                       WS_VSCROLL | WS_HSCROLL | WS_THICKFRAME |
                       WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
                       MAKE_X(4), MAKE_Y(3),
                       MAKE_X(30), MAKE_Y(14),   /* x,y,width,height */
                       hMain,          /* hParent */
                       1,              /* id */
                       hAppInstance,   /* hInst */
                       0L);            /* lpParam */
  SetWindowWord(hPanel1, 0, CreateSolidBrush(RGB(255, 0, 0)));
  CreateChildren(hPanel1);

  hPanel2=CreateWindow("Panel",        /* class */
                       "Panel2",       /* title */
                       WS_BORDER  | WS_CHILD |
                       WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX | WS_MAXIMIZEBOX |
                       WS_VSCROLL | WS_HSCROLL | WS_THICKFRAME |
                       WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
                       MAKE_X(24), MAKE_Y(6),
                       MAKE_X(30), MAKE_Y(14),   /* x,y,width,height */
                       hMain,          /* hParent */
                       2,              /* id */
                       hAppInstance,   /* hInst */
                       0L);            /* lpParam */
  SetWindowWord(hPanel2, 0, CreateSolidBrush(RGB(255, 0, 255)));
  CreateChildren(hPanel2);

  hPanel3=CreateWindow("Panel",        /* class */
                       "Panel3",       /* title */
                       WS_BORDER  | WS_CHILD |
                       WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX | WS_MAXIMIZEBOX |
                       WS_VSCROLL | WS_HSCROLL | WS_THICKFRAME |
                       WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
                       MAKE_X(44), MAKE_Y(9),
                       MAKE_X(30), MAKE_Y(14),   /* x,y,width,height */
                       hMain,          /* hParent */
                       3,              /* id */
                       hAppInstance,   /* hInst */
                       0L);            /* lpParam */
  SetWindowWord(hPanel3, 0, CreateSolidBrush(RGB(0, 0, 255)));
  CreateChildren(hPanel3);

  /*
    Show the window
  */
  ShowWindow(hPanel1, SW_SHOW);
  ShowWindow(hPanel2, SW_SHOW);
  ShowWindow(hPanel3, SW_SHOW);
  BringWindowToTop(hPanel1);
  SetFocus(hPanel1);
  CheckMenuItem(GetMenu(hMain), ID_CHILDDEMO, MF_CHECKED);
}


#ifdef MEWEL
#define SCROLL_AMT 1
#else
#define SCROLL_AMT 16
#endif

LONG FAR PASCAL PanelWndProc(HWND hWnd, WORD message, WORD wParam, LONG lParam)
{
  switch (message)
  {
#if 0
    case WM_MOUSEACTIVATE :
      BringWindowToTop(hWnd);
      return MA_ACTIVATEANDEAT;
#endif

    case WM_KEYDOWN       :
      switch (wParam)
      {
        case VK_DOWN:
          ScrollWindow(hWnd, 0,  SCROLL_AMT,  (LPRECT) NULL, (LPRECT) NULL);
          break;
        case VK_UP  :
          ScrollWindow(hWnd, 0, -SCROLL_AMT,  (LPRECT) NULL, (LPRECT) NULL);
          break;
        case VK_LEFT:
          ScrollWindow(hWnd, -SCROLL_AMT, 0,  (LPRECT) NULL, (LPRECT) NULL);
          break;
        case VK_RIGHT:
          ScrollWindow(hWnd, SCROLL_AMT, 0,   (LPRECT) NULL, (LPRECT) NULL);
          break;
        case VK_HOME:
          ScrollWindow(hWnd, -SCROLL_AMT, -SCROLL_AMT, (LPRECT) NULL, (LPRECT) NULL);
          break;
        case VK_PRIOR:
          ScrollWindow(hWnd,  SCROLL_AMT, -SCROLL_AMT, (LPRECT) NULL, (LPRECT) NULL);
          break;
        case VK_END :
          ScrollWindow(hWnd, -SCROLL_AMT,  SCROLL_AMT, (LPRECT) NULL, (LPRECT) NULL);
          break;
        case VK_NEXT:
          ScrollWindow(hWnd,  SCROLL_AMT,  SCROLL_AMT, (LPRECT) NULL, (LPRECT) NULL);
          break;
      }
      return TRUE;

    case WM_CLOSE :
      if (hWnd == hPanel1)
        hPanel1 = NULL;
      else
      if (hWnd == hPanel2)
        hPanel2 = NULL;
      else
      if (hWnd == hPanel3)
        hPanel3 = NULL;
      DeleteObject((HBRUSH) GetWindowWord(hWnd, 0));
      DestroyWindow(hWnd);
      if (!hPanel1 && !hPanel2 && !hPanel3)
        CheckMenuItem(GetMenu(hMain), ID_CHILDDEMO, MF_UNCHECKED);
      break;

    case WM_ERASEBKGND :
    {
      RECT r;
      GetClientRect(hWnd, (LPRECT) &r);
      FillRect((HDC) wParam, (LPRECT) &r, (HBRUSH) GetWindowWord(hWnd, 0));
      return TRUE;
    }

    case WM_CTLCOLOR :
      if (HIWORD(lParam) == CTLCOLOR_EDIT || HIWORD(lParam) == CTLCOLOR_STATIC)
      {
        HBRUSH   hBr = (HBRUSH) GetWindowWord(hWnd, 0);
        LOGBRUSH lb;

        GetObject(hBr, sizeof(lb), (LPSTR) &lb);
        SetBkColor((HDC) wParam, lb.lbColor);
        return hBr;
      }
      else
        return DefWindowProc(hWnd, message, wParam, lParam);

    default :
      /* Call the default window procedure for the main window */
      return DefWindowProc(hWnd, message, wParam, lParam);
  }

  return FALSE;
}


struct childinfo
{
  char *szClass;
  char *szTitle;
  int  x, y, cx, cy;
  int  id;
} ChildInfo[] =
{
  { "Static",  "Business1:",1, 0,15,1, 24 } ,
  { "Edit",  NULL,       20, 0,45,1, 25 },
  { "Static",  "Business2:",1, 2,15,1, 24 } ,
  { "Edit",  NULL,       20, 2,45,1, 25 },
  { "Static",  "Business3", 1, 4,15,1, 24 } ,
  { "Edit",  NULL,       20, 4,45,1, 25 },
  { "Static",  "Business4", 1, 6,15,1, 24 } ,
  { "Edit",  NULL,       20, 6,45,1, 25 } ,
  { "Static",  "Business5", 1, 8,15,1, 24 } ,
  { "Edit",  NULL,       20, 8,45,1, 25 },
};


static VOID PASCAL CreateChildren(HWND hParent)
{
  struct childinfo *pCI;
  int    i;
  DWORD dwStyle;
  RECT  r;

return;

  GetClientRect(hParent, &r);

  for (i = 0;  i < sizeof(ChildInfo)/sizeof(ChildInfo[0]);  i++)
  {
    pCI = &ChildInfo[i];
    if (i & 0x01)
    {
      dwStyle = ES_LEFT | WS_BORDER;
    }
    else
    {
      dwStyle = SS_LEFT;
    }

    CreateWindow(pCI->szClass, 
                 pCI->szTitle, 
                 dwStyle | WS_VISIBLE | WS_CHILD,
                 MAKE_X(pCI->x), 
                 MAKE_Y(pCI->y), 
                 MAKE_X(pCI->cx), 
                 MAKE_Y(pCI->cy),
                 hParent,        /* hParent */
                 pCI->id,        /* hMenu */
                 hAppInstance,   /* hInst */
                 0L);            /* lpParam */
  }

  CreateWindow("Button", 
               "Push Me!", 
               WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON,
               MAKE_X(1), 
               (r.bottom-MAKE_Y(1)),
               MAKE_X(10),
               MAKE_Y(1),
               hParent,        /* hParent */
               100,            /* hMenu */
               hAppInstance,   /* hInst */
               0L);            /* lpParam */

}


VOID TerminateChildDemo(VOID)
{
  if (hPanel1)
    SendMessage(hPanel1, WM_CLOSE, 0, 0L);
  if (hPanel2)
    SendMessage(hPanel2, WM_CLOSE, 0, 0L);
  if (hPanel3)
    SendMessage(hPanel3, WM_CLOSE, 0, 0L);
  CheckMenuItem(GetMenu(hMain), ID_CHILDDEMO, MF_UNCHECKED);
}


/**************************************************************************/
/*                                                                        */
/*             TIMER DEMO                                                 */
/*                                                                        */
/**************************************************************************/
#define NUMTIMERS  4
HWND hTimerWnd[NUMTIMERS];

extern LONG FAR PASCAL TimerWndProc(HWND, WORD, WORD, LONG);


VOID TimerDemo(VOID)
{
  int   i;
  HWND  hWnd;
  HMENU hMenu;
  char  title[16];
  HDC   hDC;
  TEXTMETRIC tm;
  int   cx, cy;

  if (AreTimersRunning())
    KillAllTimers();

  MessageBox(hMain,
       "The timer strings will occasionally overwrite the child windows.\nTHIS IS NOT A BUG.",
       "Heed this", MB_OK | MB_ICONEXCLAMATION);

  hDC = GetDC(hMain);
  GetTextMetrics(hDC, (LPTEXTMETRIC) &tm);
  cx = LOWORD(GetTextExtent(hDC, "555555555555", 12)) +
                             (2 * GetSystemMetrics(SM_CXBORDER));
  cy = (tm.tmHeight + tm.tmExternalLeading) +
                             GetSystemMetrics(SM_CYCAPTION) +
                             GetSystemMetrics(SM_CYMENU)    +
                             (2 * GetSystemMetrics(SM_CYBORDER));
  ReleaseDC(hMain, hDC);


  for (i = 1;  i <= NUMTIMERS;  i++)
  {
    wsprintf(title, "Timer %d", i);

    hWnd = hTimerWnd[i-1] =
       CreateWindow("Timer",        /* class */
                    title,          /* title */
                    WS_CAPTION | WS_BORDER | WS_CLIPCHILDREN | 
                    WS_CLIPSIBLINGS | WS_VISIBLE,
                    ((i-1) % 2) ? MAKE_X(50) : MAKE_X(20), 
                    MAKE_Y((((i-1) / 2) + 1) * 6),
                    cx, cy,
                    hMain,          /* hParent */
                    NULL,           /* hMenu */
                    hAppInstance,   /* hInst */
                    0L);            /* lpParam */

    hMenu = TimerMenuInit();
    SetMenu(hWnd, hMenu);
    DrawMenuBar(hWnd);
    SetTimer(hWnd, i, i*1000, (FARPROC) NULL);
  }

  ShowWindow(hMain, SW_SHOW);
  SetFocus(hTimerWnd[0]);
}


/*
  This function tests the CreateMenu and ChangeMenu functions. We could
  have loaded the menu fromt he resource file, but this shows how to
  create a menu dynamically.
*/
HMENU TimerMenuInit()
{
  HMENU hMenu, hPop;

  /*
    Create the menu bar
  */
  hMenu = CreateMenu();
  
  /*
    Create a pulldown
  */
  hPop = CreateMenu();
  ChangeMenu(hPop, 0, "&Stop",        ID_STOP,        MF_APPEND);
  ChangeMenu(hPop, 0, "&Interval",    ID_INTERVAL,    MF_APPEND);
  ChangeMenu(hPop, 0, "E&xit",        ID_EXIT,        MF_APPEND);

  /*
    Attach each of the pulldowns to their corresponding menubar entries
  */
  ChangeMenu(hMenu, 0, "&Timer",   hPop, MF_POPUP | MF_APPEND);

  return hMenu;
}


LONG FAR PASCAL TimerWndProc(HWND hWnd, WORD msg, WORD wParam, LONG lParam)
{
  char szTime[80];
  int  i;
  HDC  hDC;

  switch (msg)
  {
    case WM_TIMER :
      wsprintf(szTime, "%ld", GetTickCount());
      hDC = GetDC(hWnd);
      TextOut(hDC, 0, 0, szTime, lstrlen(szTime));
      ReleaseDC(hWnd, hDC);
      MessageBeep(0);
      return TRUE;

    case WM_CHAR    :
      if (wParam == VK_TAB)
      {
        for (i = 1;  i <= NUMTIMERS;  i++)
          if (hTimerWnd[i-1] == hWnd)
          {
            SetFocus(hTimerWnd[ (i == NUMTIMERS) ? 0 : i ]);
            return TRUE;
          }
      }
      break;

    case WM_SETFOCUS :
      BringWindowToTop(hWnd);
      return DefWindowProc(hWnd, msg, wParam, lParam);

    case WM_COMMAND :
      switch (wParam)
      {
        case ID_EXIT :
        case ID_STOP :
          for (i = 1;  i <= NUMTIMERS;  i++)
            if (hTimerWnd[i-1] == hWnd)
            {
              KillTimer(hWnd, i);
              ModifyMenu(GetMenu(hWnd),
                         ID_STOP, 
                         MF_BYCOMMAND | MF_STRING,
                         ID_START, "Start");
            }

          if (wParam == ID_EXIT)
          {
            /*
              Setting focus to a non-timer window will eliminate the
              situation where DestroyWindow(), detecting that the
              window with the focus is being destroyed, sets the focus
              to the next timer window (which will only be destroyed
              in the next interation of the for loop). This will speed
              up the process of destruction.
            */
            SetFocus(hMain);
            for (i = 1;  i <= NUMTIMERS;  i++)
            {
              DestroyWindow(hTimerWnd[i-1]);
              hTimerWnd[i-1] = NULL;
            }
          }
          break;

        case ID_START:
          for (i = 1;  i <= NUMTIMERS;  i++)
            if (hTimerWnd[i-1] == hWnd)
            {
              SetTimer(hWnd, i, i*1000, (FARPROC) NULL);
              ModifyMenu(GetMenu(hWnd),
                         ID_START, 
                         MF_BYCOMMAND | MF_STRING,
                         ID_STOP, "Stop");
            }
          break;

        case ID_INTERVAL :
          NewInterval(hWnd);
          break;
      }
      return TRUE;

    default :
      return DefWindowProc(hWnd, msg, wParam, lParam);
  }
  return TRUE;
}


VOID NewInterval(HWND hWnd)
{
  int      i, tid;
  int      interval;
  FARPROC  lpfn;

  for (i = 1;  i <= NUMTIMERS;  i++)
    if (hTimerWnd[i-1] == hWnd)
    {
      tid = i;
      break;
    }

  lpfn = MakeProcInstance(IntervalDlgProc, hAppInstance);
  if ((interval = DialogBox(hAppInstance, "IntervalDlg", hWnd, lpfn)) != IDCANCEL)
  {
    KillTimer(hWnd, tid);
    SetTimer(hWnd, tid, interval, (FARPROC) NULL);
  }
  FreeProcInstance(lpfn);
}


int FAR PASCAL IntervalDlgProc(HWND hDlg, WORD msg, WORD wParam, DWORD lParam)
{
  char szInterval[80];

  (void) lParam;

  switch (msg)
  {
    case WM_INITDIALOG :
      return TRUE;

    case WM_COMMAND :
      if (wParam == IDCANCEL)
        EndDialog(hDlg, IDCANCEL);
      else if (wParam == IDOK)
      {
        GetDlgItemText(hDlg,ID_INTERVAL, (LPSTR)szInterval,sizeof(szInterval));
        EndDialog(hDlg, atoi(szInterval));
      }
      return TRUE;

    default :
      return FALSE;
  }
}

int AreTimersRunning(VOID)
{
  return hTimerWnd[0];
}

VOID KillAllTimers(VOID)
{
  SendMessage(hTimerWnd[0], WM_COMMAND, ID_EXIT, 0L);
}


/*===========================================================================*/
/*                                                                           */
/*  POPTEST.C - demonstration of the usage of floating popups                */
/*                                                                           */
/*===========================================================================*/
VOID DoFloatingPopup(VOID)
{
  HMENU hMenu;

  if ((hMenu = LoadMenu(hAppInstance, (LPSTR) "FloatingPopup")) != NULL)
    TrackPopupMenu(GetSubMenu(hMenu,0), 0, MAKE_X(30),MAKE_Y(10), 0, hMain, 0);
}


/****************************************************************************/
/*                                                                          */
/* Function : PaintWindowWithBitmap()                                       */
/*                                                                          */
/* Purpose  : Draws the named bitmap in the window at coordinates x,y.      */
/*                                                                          */
/* Returns  : Nothing.                                                      */
/*                                                                          */
/****************************************************************************/
VOID FAR PASCAL BitmapDemo()
{
  PaintWindowWithBitmap(hMain, 0, 0, "fruit");
}

VOID PASCAL PaintWindowWithBitmap(hWnd, x, y, pBitmapName)
  HWND hWnd;
  int  x, y;
  PSTR pBitmapName;
{
  BITMAP  bmp;
  HBITMAP hOldBitmap;
  HDC     hDC, hMemDC;
  DWORD   dwTick, dwEnd, dwSecond;

  static HBITMAP hBitmap = NULL;

  if (hBitmap == NULL)
    hBitmap = LoadBitmap(hAppInstance, pBitmapName);

  if (hBitmap)
  {
    MessageBox(hWnd,
"This will show a bitmap 3 ways ...\nin its normal size, expanded, and compressed.\n\
The screen will then be cleared after 10 seconds.",
               "Bitmap Demo",
               MB_OK);

    hDC = GetDC(hWnd);
    if ((hMemDC = CreateCompatibleDC(hDC)) == NULL)
    {
      DeleteObject(hBitmap);
      return;
    }

    GetObject(hBitmap, sizeof(bmp), (LPSTR) &bmp);

    hOldBitmap = SelectObject(hMemDC, hBitmap);

#ifdef OFFSCREEN_BITMAPS_SUPORTED
    {
    int i;
    for (i = 0;  i < bmp.bmWidth;  i += 10)
    {
      MoveTo(hMemDC, i, 0);
      LineTo(hMemDC, i, bmp.bmHeight);
    }
    for (i = 0;  i < bmp.bmHeight;  i += 10)
    {
      MoveTo(hMemDC, 0, i);
      LineTo(hMemDC, bmp.bmWidth, i);
    }
    }
#endif

    BitBlt(hDC, x, y, bmp.bmWidth, bmp.bmHeight, hMemDC, 0, 0, SRCCOPY);

#define TEST_STRETCHING
#ifdef TEST_STRETCHING
    /*
      Test stretching and compressing
    */
    StretchBlt(hDC, 240, 0, 370, 400, 
               hMemDC, 0, 0, bmp.bmWidth, bmp.bmHeight, SRCCOPY);
    StretchBlt(hDC, 0, 180, 120, 90, 
               hMemDC, 0, 0, bmp.bmWidth, bmp.bmHeight, SRCCOPY);
#endif


    SelectObject(hMemDC, hOldBitmap);
    DeleteDC(hMemDC);
#if 1
    /*
      Don't delete the bitmap cause it takes time to reload and change from
      a DIB to a DDB
    */
    DeleteObject(hBitmap);
#endif

    ReleaseDC(hWnd, hDC);

    dwTick   = GetTickCount();
    dwEnd    = dwTick + (1000L * 10L);
    dwSecond = dwTick + (1000L * 1L);
    while ((dwTick = GetTickCount()) < dwEnd)
    {
      if (dwTick > dwSecond)
      {
        dwSecond = dwTick + 1000L;
        MessageBeep(0);
      }
    }

    InvalidateRect(hWnd, (LPRECT) NULL, TRUE);
  }
}

#ifdef MEMDEBUG
#include <dos.h>
long memavail(void)
{
  union REGS regs;

  regs.h.ah = 0x48;
  regs.x.bx = 0xFFFF;
  int86(0x21, &regs, &regs);
  return(16L * regs.x.bx);
}
#endif


#ifdef __HIGHC__
void *mwGrafAlloc(size)
  size_t size;
{
  return malloc(size);
}

void mwGrafFree(ptr)
  void *ptr;
{
  free(ptr);
}
#endif

